package streams.übungen;

import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

public class Main {

	public static void main(String[] args) {
	
		countryTest();
		
	
	}
	
	public static void countryTest() {
		CountryTest test = new CountryTest();
		//Q.2) Find the most populated city of each country
		Map<Country,City> q2 = test.test
				.stream()
				.parallel()
				.collect(Collectors.toMap(
						country -> country,
						country -> country.getCities().stream()
							.max(Comparator.comparingInt(t -> t.getPopulation()))
							.orElse(null)
						));
		
	//	q2.forEach((a,b) -> System.out.println(a + " " + b));
		
		
		//finde die Länder mit ihrer Städte.
		Map<Country,List<City>> q6 = test.test
			.stream()
			.collect(Collectors.toMap(
					country -> country,
					country -> country.getCities().stream()
					.collect(Collectors.toCollection(ArrayList::new))
					));
		
			//q6.forEach((a,b) -> System.out.println(a + " " + b.toString()));
			
		
			// Durchschnitt jedes Land 
			Map<Country, Double> q5 =  test.test.stream()
				.collect(Collectors.toMap(
						country -> country,
						country -> country.getCities().stream()
						.collect(Collectors.averagingDouble(e -> e.getPopulation()))));
			
			//q5.forEach((a,b) -> System.out.println(a + " " + b));
//			
//			test.test.stream()
//			.forEach(t -> {
//				System.out.println(t.getName());
//				t.getCities().stream()
//				.forEach(f -> System.out.println("Stadt: " + f.getName()));
//			});
			
			
			  // Paralleler Stream mit forEach (Reihenfolge nicht garantiert)
	        System.out.println("Paralleler Stream mit forEach:");
	        ArrayList<Integer> s1  = new ArrayList<>();
	        s1.add(1);
	        s1.add(5);
	        s1.add(4);
	        s1.add(2);
	        s1.parallelStream().sorted().forEach(System.out::println);
	        ArrayList<Integer> s4 = s1.stream().parallel().sorted().collect(Collectors.toCollection(ArrayList::new));
	        System.out.println(s4);
	        
	        System.out.println("\nParalleler Stream mit forEachOrdered:");
	        // Paralleler Stream mit forEachOrdered (Reihenfolge garantiert)
	        ArrayList<Integer> s2  = new ArrayList<>();
	        s2.add(1);
	        s2.add(5);
	        s2.add(4);
	        s2.add(2);
	        s2.parallelStream().sorted().forEachOrdered(System.out::print);
	}
	
	public static void cityTest() {
		CityTest test = new CityTest();
		//Map<Integer, List<City>>
		City x  = test.cities.values()
				.stream()
				.max(Comparator.comparingInt(c -> c.getPopulation()))
				.orElse(null);
		
		System.out.println(x.toString());
		
		Map<String, List<City>> nachCod = test.cities.values()
				.stream()
				.collect(Collectors.groupingBy(t -> t.getCountryCode(), Collectors.toCollection(ArrayList::new)));
		
		nachCod.forEach((a,b) -> System.out.println("countryCode: " + a + " " + b));
				
	}
	
	public static void movieTest() {
		MovieTest test = new MovieTest();
//		
//		Map<Director, Long> moviesPerDirector = test.movies.values().stream()
//		.flatMap(movie -> movie.getDirectors().stream())
//		 .collect(Collectors.groupingBy(director -> director, Collectors.counting())); // Gruppieren und zählen		
//	
//	
//		   moviesPerDirector.forEach((director, count) -> {
//	            System.out.println("Director: " + director.getName() + ", Movies: " + count);
//	        });
//		   
//		
//		  Map<Genre,Long> anzahlGenresjedesFilm = test.movies.values().stream()
//				  .flatMap(movie -> movie.getGenres().stream())
//				  .collect(Collectors.groupingBy(g -> g , Collectors.counting()));
//		  
//		  anzahlGenresjedesFilm.forEach((genre, count) -> {
//			  System.out.println("Genre: " + genre.getName() + ", Movies: " + count);
//		  });
		
		Map<Boolean, List<Movie>> movies = test.movies
				.stream()
				.collect(Collectors.partitioningBy(m -> m.getGenre().equalsIgnoreCase("Drama") ||  m.getGenre().equalsIgnoreCase("Komödie"), Collectors.toCollection(ArrayList::new)));
		
//		List<Movie> ohne = movies.get(false);
//		ohne.forEach(System.out::println);
		
//		List<Movie> mit = movies.get(true);
//		mit.forEach(System.out::println);
		
		Map<Integer, List<Movie>> nachJahr = test.movies
				.stream()
				.collect(Collectors.groupingBy(m -> m.getYear(), Collectors.toCollection(ArrayList::new)));
		
		nachJahr.forEach((a,b) -> System.out.println(a  +" "+ b + "\n"));
	}

}
